KotlinのrunCachingでonSuccessせずに値を返却する

Kotlinでエラーハンドリングするときのやり方


・try-catch

val a = try {
    "masterka"
} catch(e: Exception) {
    ""
}
println(a)

 

・runCachingするなら

val a = kotlin.runCatching {
            "masterka"
        }.getOrDefault("test")
println(a)
//masterkaが出力される
val a = kotlin.runCatching {
            throw Exception("masterka")
        }.getOrDefault("test")
println(a)
//testが出力される

 

runCatchingした結果はsucessとかでラップする必要ないんだね
エラーを無理やり潰すならいこれで良さそう

関連記事:

Pocket